# Copyright (c) 2025, NVIDIA CORPORATION.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Configuration for LoRA fine-tuning Gemma 4 26B-A4B MoE (128 experts) with MedPix dataset
# Requires 8 GPUs (FSDP2 + EP=8, 16 experts per GPU)
# torchrun --nproc-per-node=8 examples/vlm_finetune/finetune.py -c examples/vlm_finetune/gemma4/gemma4_26b_a4b_moe_peft.yaml

recipe: FinetuneRecipeForVLM

step_scheduler:
  global_batch_size: 8
  local_batch_size: 1
  ckpt_every_steps: 500
  val_every_steps: 500
  num_epochs: 2

dist_env:
  backend: nccl
  timeout_minutes: 60

rng:
  _target_: nemo_automodel.components.training.rng.StatefulRNG
  seed: 42
  ranked: true

model:
  _target_: nemo_automodel.NeMoAutoModelForImageTextToText.from_pretrained
  pretrained_model_name_or_path: google/gemma-4-26B-A4B-it
  torch_dtype: torch.bfloat16
  trust_remote_code: true
  attn_implementation: sdpa
  backend:
    _target_: nemo_automodel.components.models.common.BackendConfig
    attn: te
    linear: te
    rms_norm: te
    rope_fusion: true
    dispatcher: deepep
    fake_balanced_gate: false
    enable_hf_state_dict_adapter: true
    enable_fsdp_optimizations: true
  text_config:
  # 26B-A4B does not use kv_shared layers (only used in 2B, 4B), hence use_cache: false.
    use_cache: false

peft:
  _target_: nemo_automodel.components._peft.lora.PeftConfig
  match_all_linear: False
  exclude_modules:
    - "*vision_tower*"
    - "*vision*"
    - "*visual*"
    - "*image_encoder*"
    - "*lm_head*"
    - "*audio*"
  dim: 16
  alpha: 32
  use_triton: True

checkpoint:
  enabled: true
  checkpoint_dir: vlm_checkpoints/gemma4_26b_a4b_moe_peft/
  model_save_format: safetensors
  save_consolidated: false

distributed:
  strategy: fsdp2
  dp_size: none
  tp_size: 1
  cp_size: 1
  ep_size: 8

  sequence_parallel: false

loss_fn:
  _target_: nemo_automodel.components.loss.masked_ce.MaskedCrossEntropy

dataset:
  _target_: nemo_automodel.components.datasets.vlm.datasets.make_medpix_dataset
  path_or_dataset: mmoukouba/MedPix-VQA
  split: train[:1000]

dataloader:
  _target_: torchdata.stateful_dataloader.StatefulDataLoader
  num_workers: 0
  pin_memory: true
  collate_fn:
    _target_: nemo_automodel.components.datasets.vlm.collate_fns.gemma4_prefix_collate_fn

validation_dataset:
  _target_: nemo_automodel.components.datasets.vlm.datasets.make_medpix_dataset
  path_or_dataset: mmoukouba/MedPix-VQA
  split: validation[:500]

validation_dataloader:
  _target_: torchdata.stateful_dataloader.StatefulDataLoader
  collate_fn:
    _target_: nemo_automodel.components.datasets.vlm.collate_fns.gemma4_prefix_collate_fn

optimizer:
  _target_: torch.optim.AdamW
  lr: 2e-4
  weight_decay: 0.01
  betas: [0.9, 0.95]

lr_scheduler:
  lr_decay_style: cosine

freeze_config:
  freeze_embeddings: true
  freeze_vision_tower: true
  freeze_audio_tower: true
  freeze_language_model: false

# wandb:
#   project: <your-project>
#   entity: <your-entity>
#   name: <your-run-name>

ci:
  recipe_owner: athitten
  time: "00:20:00"
